library(mcclust)

input <- data.frame(read.csv("pca.csv"), row.names=1)

rownames(input) <- do.call(paste, as.list(cbind(input["SECTION"], rownames(input))))
mydata <- input[,-1]
d <- 1 - abs(cor(t(mydata))) # correlation dissimilarity distance matrix

fit <- hclust(as.dist(d), method="ward") 

rand_performance <- function (k) arandi(input$SECTION, cutree(fit, k=k))
optimised <- optimise(rand_performance, 7:54, maximum=TRUE)
k <- round(optimised$maximum)

cat(k, "clusters found\n")
cat("adj. rand index is ", optimised$objective, "\n")

groups <- cutree(fit, k=k)
input$PREDICTED <- groups

write.csv(input, "with_clusters.csv")

png("hier_clusters.png", width=1024, height=800)
plot(fit)
rect.hclust(fit, k=k, border="red")

