import urllib2
import os.path

def get_pages(urls_filename, out_folder, get_url_func, name_func):
    """ Downloads pages from urls_file to separate files in out_folder.
    
    get_url_func is called with current line as argument and is expected
                 to return a tuple (name, url)
    name_func    is called with section, name, url as arguments and
                 is expected to return filename in output folder where
                 the downloaded page should be saved
    """
    with open(urls_filename) as f:
        section = f.readline()
        line = f.readline()
        while section != "":
            
            while line.strip() != "":
                try:    
                    name, url = get_url_func(line)
                except ValueError:
                    line = f.readline()
                    continue
                    
                filename = os.path.join(out_folder, name_func(section, name, url))
                
                if os.path.exists(filename):
                    line = f.readline()
                    continue
                
                print "url = %s" % url
                response = urllib2.urlopen(url)
                html = response.read()
                            
                with open(filename, "w") as out:
                    out.write(html)
                
                line = f.readline()
                
            section = f.readline()
            line = f.readline()    
            
if __name__ == "__main__":
    get_pages("feeds_urls.edited", "feeds", lambda line: line.split(), lambda section, name, url: name)
    get_pages("feeds_urls.edited", "html", lambda line: (line.split()[0], "http://"+line.split()[0]), lambda section, name, url: name)
