# encoding: utf-8
"""
Transform scores to tf-idf.
"""
import sys
import csv
import numpy
import math

delta = 0.00000000001

def main(filename):
    with open(filename) as infile:
        r = csv.reader(infile)
        w = csv.writer(sys.stdout)
        fieldnames = r.next()
        
        # find start of features
        for n_of_labels, name in enumerate(fieldnames):
            if name.lower() == name:
                break
        
        rows = []
        dfs = {} 
        
        for row in r:
            rows.append(row)
            for i, freq in enumerate(row[n_of_labels:]):
                freq = float(freq)
                if freq > delta:
                    word = fieldnames[i + n_of_labels]
                    dfs[word] = dfs.get(word, 0) + 1
        
        idfs = {}
        n_documents = len(rows)
        for word, df in dfs.iteritems():
            idf = math.log(float(n_documents) / df)
            idfs[word] = idf
        
        w.writerow(fieldnames)
        for row in rows:
            for i in range(n_of_labels, len(row)):
                tf_idf = float(row[i]) * idfs[fieldnames[i]]
                
                row[i] = tf_idf
            w.writerow(row)
        

if __name__ == "__main__":
    main(*sys.argv[1:])
