# encoding: utf-8
"""
Blog features matrix normalization (row-wise). This is a correction for uneven word number in different blogs.
"""
import sys
import csv
import numpy

VECTOR_LENGTH = 1.0

def main(args):
    with open(args[1]) as infile:
        r = csv.reader(infile)
        w = csv.writer(sys.stdout)
        fieldnames = r.next()
        w.writerow(fieldnames) 
        
        # find start of features
        for n_of_labels, name in enumerate(fieldnames):
            if name.lower() == name:
                break
        
        for row in r:
            vector = numpy.array(row[n_of_labels:], dtype=numpy.double)
            vector /= numpy.sqrt(numpy.dot(vector, vector))
            row[n_of_labels:] = vector
            w.writerow(row)
        

if __name__ == "__main__":
    main(sys.argv)
