TechCrunch is a group-edited blog that profiles the companies, products and events defining and transforming the new web.
TechCrunch
"Consumer Internet entrepreneurs are like pro basketball players," a venture capitalist told me recently while discussing the prospects for a thirty-something founder, "They peak at 25, by 30 they're usually done." 

Why? Because young entrepreneurs are more creative and imaginative, and are willing put 100% of their lives into their startups, he said. "It's not a guess, this is a data driven observation," says the VC.

He had a number of caveats. First, this only applies to consumer Internet entrepreneurs. Enterprise and hardware startups tend to do better with older founders, where experience (and direct sales experience) matter a lot. And there are plenty of founders that, like Michael Jordan, can peak way beyond 25 (and the peak basketball age is really probably at least a 27). "Those tend to be the repeat success founders," he said, "the rules don't apply to them."
Internet Entrepreneurs Are Like Professional Athletes, They Peak Around 25
“Consumer Internet entrepreneurs are like pro basketball players,” a venture capitalist told me recently while discussing the prospects for a thirty-something founder, “They peak at 25, by 30 they’re usually done.” 
 Why? Because young entrepreneurs are more creative and imaginative, and are willing put 100% of their lives into their startups, he said. “It’s not a guess, this is a data driven observation,” says the VC. 
 He had a number of caveats. First, this only applies to consumer Internet entrepreneurs. Enterprise and hardware startups tend to do better with older founders, where experience (and direct sales experience) matter a lot. And there are plenty of founders that, like Michael Jordan, can peak way beyond 25 (and the peak basketball age is really probably at least a 27). “Those tend to be the repeat success founders,” he said, “the rules don’t apply to them.” 
 Peak age of startup founders is an endless debate. Vivek Wadhwa says his data shows that older entrepreneurs are more successful , for example. He argues that ageism is more about exploiting young people more than getting value for money. 
 Other data suggests the opposite. Like this – last year Y Combinator said the average age of their founders is under 25 . Of course they could have selection bias, but Y Combinator is one of the most data driven investors I’ve heard of. if older people did better, they’d be funding more of them. 
 At Disrupt in New York in May we’ve got a very cool interview planned. SV Angel says they’ve analyzed deep demographic data for their 500+ investments over the last twelve years or so. It takes years to know how successful a startup will eventually be, so this is particularly valuable data. 
 Will they agree that Internet startup founders should be looking to make a name for themselves before they hit 30, or give up? We’ll know in a few short weeks.
Ever heard of Dropship ? It's an open-source project that "enables arbitrary, anonymous transfers of files between Dropbox accounts." Dropbox hopes you haven't; they tried to squelch it this week, and even accidentally reported that it was subject to a DMCA takedown notice, with predictably futile results. I'm mostly sympathetic: I'm a huge fan of their service, Dropship was a clear violation of their terms, and for obvious reasons they don't want to turn into an anonymous peer-to-peer file-sharing service. Unfortunately, they accidentally built a system which enabled just that.

How about Sony's PlayStation Network? Of course you have. It was so thoroughly hacked this week that Sony had to shut it down indefinitely . Did you also know that Sony's PS3 firmware is effectively wide open, because they made a hilariously stupid security mistake ? Did you know that that's probably how PSN got hacked , and that it raised the spectre of the hacker(s) taking over every connected PlayStation 3 in the world and turning them into by far the biggest botnet in history? That probably wasn't what Sony had in mind, but they accidentally built a system which enabled just that.
The Cloud Has Us All In A Fog
Ever heard of Dropship ? It’s an open-source project that “enables arbitrary, anonymous transfers of files between Dropbox accounts.” Dropbox hopes you haven’t; they tried to squelch it this week, and even accidentally reported that it was subject to a DMCA takedown notice, with predictably futile results. I’m mostly sympathetic: I’m a huge fan of their service, Dropship was a clear violation of their terms, and for obvious reasons they don’t want to turn into an anonymous peer-to-peer file-sharing service. Unfortunately, they accidentally built a system which enabled just that. 
 How about Sony’s PlayStation Network? Of course you have. It was so thoroughly hacked this week that Sony had to shut it down indefinitely . Did you also know that Sony’s PS3 firmware is effectively wide open, because they made a hilariously stupid security mistake ? Did you know that that’s probably how PSN got hacked , and that it raised the spectre of the hacker(s) taking over every connected PlayStation 3 in the world and turning them into by far the biggest botnet in history? That probably wasn’t what Sony had in mind, but they accidentally built a system which enabled just that. 
 How about the new Google Docs Android app? Came out this week, and it’s pretty great. Among its many features is the ability to take a picture of an image with text and have that text automatically OCRed and turned into a document. Can’t wait ’til they integrate Google Translate into that, too, and recapitulate last year’s hot app World Lens . But I bet book publishers are pretty unhappy. Not long ago, if you wanted to scan a book you had to actually build a scanner , or buy a copy and turn every page. Now would-be book pirates can just crowdsource 10 people to go to bookstores and take 20 pictures each, et voila: 400 scanned pages in Google Docs. Easier book piracy probably isn’t what Google had in mind, but they accidentally built a system which enables just that. 
 This was also the week that people who keep remotely controllable Internet-enabled camera/microphone/GPSes on them at all times expressed outraged surprise when they learned their privacy is at risk. The panopticon probably isn’t what the mobile industry had in mind, but they accidentally built a system which enables just that. 
 What do these all have in common? The unexpected results of connecting client devices to the cloud. (Yeah, I don’t really like the term either, but it’s better than the alternatives.) People talk about “moving to the cloud,” as if we haven’t already. The heavy lifting may happen on the server farms ( when they’re up ) but every connected computer, phone, and game console already serves as a computing cloud’s eye, ear, and tentacle. 
 Emergent properties . Unintended consequences. Get used to ‘em. My favourite Douglas Adams books are the Dirk Gently novels, in which the protagonist makes use of “the fundamental interconnectedness of all things” to solve crimes in hilariously unexpected ways. Now we’re literally building that interconnectedness into (nearly) all things . So we shouldn’t be too surprised to find ourselves moving into a Dirk Gently future, in which off-kilter left-field ricochet consequences happen at an ever-increasing rate. You can bet that those cited above are just the beginning — and that there’s a lot of money to be made in seeing them before they happen. 
 Photo credit : Aspex Design, Flickr
The Gillmor Gang — Kevin Marks, Danny Sullivan, JP Rangaswami, John Taschek, and Steve Gillmor — christened the new Gang studio with a surprise welcome to Kevin Marks. It turns out he's joining salesforce.com on Monday, following JP (six months), JT (7 years), and me, who is celebrating my one year anniversary. Kevin has been a forceful champion of open standards at Apple, Technorati, Google, BT (Ribbit), the Gillmor Gang, and now salesforce.com. Before, and once the festivities were out of the way, we got back to Gang business, namely the continued aftermath of the phone location recording crisis.

With free lunch debunked, we tackled the Amazon outage and its impact on the Cloud. You can decide for yourselves, but the consensus is that such challenges will be remembered fondly as a validation of the moment, as with the Gmail outage of several years ago, when the Cloud passed from inflection point to basic services. The velocity of business in the iPad age, where CEOs can see deeply into their companies in realtime, demands a level of interactive services and an iterative feedback loop not possible with the previous generation of software. And that lead to a debate about iPhone video calls and what Danny is looking for in a flying car.
Gillmor Gang 4.30.11 (TCTV)
The Gillmor Gang — Kevin Marks, Danny Sullivan, JP Rangaswami, John Taschek, and Steve Gillmor — christened the new Gang studio with a surprise welcome to Kevin Marks. It turns out he’s joining salesforce.com on Monday, following JP (six months), JT (7 years), and me, who is celebrating my one year anniversary. Kevin has been a forceful champion of open standards at Apple, Technorati, Google, BT (Ribbit), the Gillmor Gang, and now salesforce.com. Before, and once the festivities were out of the way, we got back to Gang business, namely the continued aftermath of the phone location recording crisis. 
 With free lunch debunked, we tackled the Amazon outage and its impact on the Cloud. You can decide for yourselves, but the consensus is that such challenges will be remembered fondly as a validation of the moment, as with the Gmail outage of several years ago, when the Cloud passed from inflection point to basic services. The velocity of business in the iPad age, where CEOs can see deeply into their companies in realtime, demands a level of interactive services and an iterative feedback loop not possible with the previous generation of software. And that lead to a debate about iPhone video calls and what Danny is looking for in a flying car. 
 CrunchBase Information  Steve Gillmor  JP Rangaswami  John Taschek  Danny Sullivan  Kevin Marks  Information provided by CrunchBase
The talent wars that were common back in the late 90′s appear to have returned whether it’s using  LOLCats  or  cheeseburgers  to recruit talent. While I love the creativity, when it comes down to making a decision to join a new company, the lumbering tech giants (Google, Microsoft, Amazon, Zynga, Facebook) which startups compete against for talent have one giant ace up their sleeve — great healthcare benefits. 

When I left Microsoft 8 years ago, my wife expressed only one concern — losing health benefits. At the time, I told her that it’s just a matter of paying those costs directly. The reality has been that it’s been a significant hassle and cost that we’d rather not deal with.  The excitement of working with startups has outweighed that hassle, but even to this day it remains a burr in the saddle. Periodically, I will get an offer to join some company and her first question is “how are their health benefits?” Startups have repeatedly shown an ability to outmaneuver the behemoths we compete with but this is one area where the behemoths still have an edge.  It’s time to turn the tables with what I call Do-it-Yourself (DIY) Healthcare Reform.
How DIY Health Reform Can Help You Win The Talent Wars
Editor’s note : Guest author Dave Chase spent the 90′s working at Microsoft in various senior marketing and general management roles, including founding Microsoft’s global healthcare unit that has grown to be Microsoft’s most significant vertical market. Prior to joining Microsoft, he was a senior consultant with Accenture’s Healthcare Practice working with a wide array of healthcare providers and systems. Dave has also been a successful investor and adviser to several early-stage companies. He can be found on Twitter as @ chasedave  or on  LinkedIn . 
 The talent wars that were common back in the late 90′s appear to have returned whether it’s using  LOLCats  or  cheeseburgers  to recruit talent. While I love the creativity, when it comes down to making a decision to join a new company, the lumbering tech giants (Google, Microsoft, Amazon, Zynga, Facebook) which startups compete against for talent have one giant ace up their sleeve — great healthcare benefits. 
 When I left Microsoft 8 years ago, my wife expressed only one concern — losing health benefits. At the time, I told her that it’s just a matter of paying those costs directly. The reality has been that it’s been a significant hassle and cost that we’d rather not deal with.  The excitement of working with startups has outweighed that hassle, but even to this day it remains a burr in the saddle. Periodically, I will get an offer to join some company and her first question is “how are their health benefits?” Startups have repeatedly shown an ability to outmaneuver the behemoths we compete with but this is one area where the behemoths still have an edge.  It’s time to turn the tables with what I call Do-it-Yourself (DIY) Healthcare Reform. 
 While the behemoths stick to the old health payment model, which is a  Gordian Knot  designed by Rube Goldberg , there’s a better way. The big companies can stick with a model that has led to health costs increasing 274x in my lifetime (compared to 8x for all other consumer goods and services). What’s better is that startups are beginning to offer key parts of the solution.  There’s a Seattle startup called Qliance that is backed by Nick Hanauer (aQuantive founder, Second Avenue Partners), Rich Barton (Expedia/Zillow founder), Jeff Bezos and Michael Dell. (I am not an investor).  In the Bay Area, there’s a similar model – One Medical Group – that has been written up in the  NY Times 
 Qliance and medical approaches like it recognize the budget-crushing impact of burdening the health equivalent of a car tune-up with insurance bureaucracy and profits. There’s a 40% “tax” that makes healthcare insurance unnecessarily expensive. Instead, in Qliance-like models, the health insurer gets disintermediated from day to day healthcare. It keeps insurance for what it does best—covering you for catastrophic items you hope never happen (major medical issues, house fire, car accident). 
 The Solution 
 There are steps an individual or companies can take today that can save a massive amount of money.  I will explain three items that may be new to you but are important to understand and take advantage of depending on the scope of coverage you want for yourself or your employees. 
 
 Direct Primary Care (DPC) : A relatively new concept that is a derivation of  Concierge Medicine  but targeted at the mass market. They typically cover everything from day to day items (physicals, flu, etc.) to urgent care. Sometimes there are added charges for items such as an X-ray (Qliance now includes this in their pricing) or lab tests where they pass along direct costs. Because it’s completely outside of the insurance model (you pay a monthly retainer not unlike a health club that you can use as much or as little as you’d like), doctors are happy to be available by email and phone. In a typical insurance/fee-for-service model, they wouldn’t get compensated unless they see you in person so it’s understandable why they are reluctant to be available for their patients in this manner. 
 Health Savings Accounts (HSA) : These allow pre-tax dollars to be put into an account that rolls over if they aren’t used. Funds in the account can be used to pay for qualified healthcare expenses. As pre-tax money, you are essentially getting a 20-30% discount depending on your tax bracket. The funds contributed to the account are not subject to federal income tax at the time of deposit. Unlike a  flexible spending account  (FSA), funds roll over and accumulate year to year if not spent. HSA funds may currently be used to pay for qualified medical expenses at any time without federal tax liability or penalty. More on them can be found at the  federal government’s Web site  and on  Wikipedia . 
 Health Discount Card : Think of this as a Costco Card for health & wellness services. It’s NOT insurance. Your Costco Card doesn’t allow you to take Cheerios off their shelf and not pay for them. Rather, they have aggregated the buying power of individuals and small business to save their members money when they purchase something. With the card, you can access items often not covered by insurance from Dental to Vision to Alternative Care to Prescriptions at a significant pre-negotiated discount. 
 
 The following are examples of the range of coverage you can provide to your team. I would always recommend at least having a very high deductible insurance plan. 
 
 Bare bones : At least offer a Health Discount Card even if you can’t cover the employee’s High Deductible Insurance Plan. Just be sure to communicate that it is not insurance as many will think it is. The Costco analogy helps people understand (i.e., you can’t walk out without paying for what’s in your cart, it just costs less). 
 Good : Couple a High Deductible Plan with a Health Discount Card 
 Better : Combine the “Good” with a HSA that you fund with pre-tax dollars. Employers such as Whole Foods have taken this approach and found their employees getting much savvier on spending “their” dollars. See the  Wall Street Journal’s piece by Whole Foods CEO  on how they do this. Even if you don’t fund the HSA, it’s great to offer one as a way for employees to extend their dollars. 
 Best : Combine the “Better” with a Direct Primary Care membership. Prices vary widely but Qliance charges $69/month for a 40-49 year old, for example. Many find that combining these can actually cost less than conventional insurance. Some are going a step further and offering corporate wellness programs such as those offered by startups such as  Lime-Ade . 
 
 My experience initially working as a management consultant to nearly 30 hospitals followed by founding Microsoft’s healthcare business has led me to the conclusion that it is virtually impossible to reform a fundamentally flawed model (i.e., the payment side of the equation). I outlined this in more detail in my Huffington Post piece entitled  Health Insurance’s Bunker Buster . But taking giving employees new healthcare choices is one way startups can compete with larger companies in the talent wars. 
 CrunchBase Information  Dave Chase  Qliance Medical Management  Information provided by CrunchBase
The business model of incentivized app downloads was recently dealt a death sentence by Apple.   Apple said incentivized app downloads were driving inaccurate rankings in the App Store , almost certainly because essentially paying consumers to download apps was a way of gaming a ranking system that used  downloads  as a key metric.  To be fair, there were many quality apps taking advantage of the loophole in the ranking system, but that era has ended. And so have the days of companies making money hand over fist in the incentivized downloads business, better known in the industry as Cost Per Install or CPI.

 So how exactly did it work ? Say you’re playing a game that offers you virtual currency; the game might ask you to download an advertised application in exchange for virtual credits within that game. You install the app and get your in-game currency. The app gets a new install and pays for that.  This quickly generates bursts of installs, immediately boosting an app’s ranking in the app store.
Game Over for Incentivized App Downloads
Editor’s note : Guest author Gurbaksh Chahal has founded three startups and is currently CEO and founder of  RadiumOne,  an online ad network that aims to combine social and intent data to serve ads. 
 The business model of incentivized app downloads was recently dealt a death sentence by Apple.   Apple said incentivized app downloads were driving inaccurate rankings in the App Store , almost certainly because essentially paying consumers to download apps was a way of gaming a ranking system that used  downloads  as a key metric.  To be fair, there were many quality apps taking advantage of the loophole in the ranking system, but that era has ended. And so have the days of companies making money hand over fist in the incentivized downloads business, better known in the industry as Cost Per Install or CPI. 
 So how exactly did it work ? Say you’re playing a game that offers you virtual currency; the game might ask you to download an advertised application in exchange for virtual credits within that game. You install the app and get your in-game currency. The app gets a new install and pays for that.  This quickly generates bursts of installs, immediately boosting an app’s ranking in the app store. 
 My feeling about this change in the App Store ranking—“Hooray!” I’m glad that Apple put a stake in the heart of this “quick buck” scheme. It’s going to force everyone in the mobile space to get back to making money the old school way—with real and targeted advertising. 
 The companies in the CPI business ( TapJoy ,  Flurry ,  mdotm ,  w3i ) were slowing this transition and this focus. And they all knew that CPI was a house of cards revenue stream that was not sustainable and wouldn’t be ignored by Apple indefinitely. Furthermore, CPI is a business model with constrained inventory. You can only monetize to the number of apps in the network. That’s always going to be a finite number and a small number when most app developers aren’t big enough to even afford CPI. 
 So what replaces CPI?  In my opinion—and granted I’m biased because I’ve founded three companies that serve online display advertising—mobile display ad solutions are the way of the future. Display offers a much greater growth potential than CPI because of near limitless inventory.  The IAB recently estimated  that last year alone, advertisers spent more than $550 million on mobile advertising.  That pace is outstripping the growth of online display and CPI is no match. 
 Mobile advertising is a rapidly iterating field. In many ways this CPI ruckus is reminiscent of the early days of online display. Remember the days before IAB standards, when click fraud was rampant and there was a virtual cornucopia of monetization schemes offered by now defunct companies that were “gaming” the system? 
 The next chapter in mobile advertising, for the companies able to keep up with the pace of change, will be better ad solutions for app developers, advertisers and consumers.  Just consider this: Over 25% of current mobile landing pages go to the App Store.  Display can drive App Store rankings.  Think about what the seer of Internet advertising, Kleiner Perkins’ Mary Meeker noted in her  Top Mobile Internet Trends  report : 
 
 Mobile display is hitting a critical mass faster than the desktop Internet did 
 Powerful shift to ad and virtual good monetization from initial pay per download models 
 About 60% of time spent on smartphones is new activity for mobile users – activities such as games, social networking, maps, utilities. 
 
 So let’s say farewell and good riddance to mobile CPI and find better advertising models that actually give consumers something they want.
I've been in Las Vegas for most of the month and so have been out of the loop on some of the major stories rocking the world of technology and media. Stories like the startling news that, having made a sack-load of money from the sale of TechCrunch to AOL, Mike is going to begin investing in start-ups again .

Like most jealous little fucks with a Wordpress login uncompromising guardians of media impartiality , I was shocked - shocked - at the news, but unlike most of those guardians, I was reassured by the honesty of his disclosure. I also laughed at HuffPost's official statement that - well - Mike is special and that everyone should stop whining.
An Update To My Ethics Policy
I’ve been in Las Vegas for most of the month and so have been out of the loop on some of the major stories rocking the world of technology and media. Stories like the startling news that, having made a sack-load of money from the sale of TechCrunch to AOL, Mike is going to begin investing in start-ups again . 
 Like most jealous little fucks with a WordPress login uncompromising guardians of media impartiality , I was shocked – shocked – at the news, but unlike most of those guardians, I was reassured by the honesty of his disclosure. I also laughed at HuffPost’s official statement that – well – Mike is special and that everyone should stop whining. 
 “Michael Arrington operates from a unique position. He was an investor in technology companies and start-ups before he started TechCrunch, and his extensive knowledge of, and involvement with Silicon Valley is one of the very things that has made TechCrunch a must-read site. TechCrunch is committed to transparency.” 
 Indeed we are. And so, prompted by Mike’s ethical pivot, I’ve decided it’s time to update my own code of conduct, the previous version of which can be found here . After all, in the two years since I last updated the document, I’ve quit drinking , received another book advance and – yeah – made some cash from my own TechCrunch shares. The drinking thing alone has left me with more spare cash that I know what to do with. 
 Here then, for the record, are the relevant changes to my core ethics now that I am sickeningly rich… 
 “Principle One: I am a whore.” 
 In the previous version of my ethics statement, I explained that the quality of my work is directly related to how much I’m paid…. 
 “Look at the cover of my book . See the word Whore? It’s in red. That’s because I am a whore; a hussy; a slut-for-hire; a man of scarlet letters. I write newspaper columns because people pay me to do so. I write books for the same reason. The more I get paid, the better I write…” 
 …Now that I am dripping with wealth, that is no longer the case. Henceforth, the quality of my work will be related only to whether I can be bothered to get out of bed in the morning. (Today was a sleepy day) 
 “Principle Four: What are friends for?” 
 Previously, I made clear that I would generally write mean things about my enemies and nice things about my friends… 
 “If you’re my friend I will write nice things about you; if you’re not I probably won’t.” 
 …Now that I have more money than I know what to do with, however, I no longer feel any loyalty towards my friends; I can always buy new ones. As for my enemies – I don’t need to write about them to get revenge; I can simply pay to have them killed. 
 In terms of my day-to-day interactions with PR professionals, I previously adopted a non-discrimination policy…. 
 “When trying to hook up with your PR girl at your party, how attractive she is will play almost no part in my decision making. That would smack of discrimination.” 
 …That policy is no longer in operation. 
 “Bribery: If you buy me a Happy Meal as a bribe, I will refuse to accept the free toy. See also, Kinder Surprise eggs.” 
 A couple of simple text changes to the above. For “Kinder Surprise eggs”, now read “Fabergé Eggs”. For “Happy Meal”, read “Happy Ending”. 
 And finally, an all important note on stocks. In the previous iteration of my ethics statement, I made clear that I try to avoid owning stocks as all of my investments very quickly turn to shit. This is still the case, except now I deliberately invest my vast wealth in things specifically in the hope that my involvement will lead to their downfall. 
 Recent investments include $5,000 for 60% of ZDNet’s Tom Foremski’s sense of proportion and a little over $3.50 for a controlling stake in the editorial integrity Forbes.com. Both investments are performing nicely.
WARNING: mixed sports metaphors ahead.

How many do-overs does a startup get before users give up on it for good? As far as I can remember, the answer is zero. I can't think of an example where a startup launched into the wild, flailed badly, and recovered (without completely abandoning the first product). There are lots of examples of flailing and relaunching (see Cuil, see Joost), but I can't think of anyone that managed to pull out a win.

By my count Color , the $41 million startup that promises to "transform the way people communicate with each other," has already struck out. 

The first strike was a launch that left users confused, sharing photos with themselves and trying to figure out a user interface that seemed purposely designed to frustrate. We gave them another chance .

Strike two: pulling the Android version of the app from the market.
How Many Mulligans Does Color Get?
WARNING: mixed sports metaphors ahead. 
 How many do-overs does a startup get before users give up on it for good? As far as I can remember, the answer is zero. I can’t think of an example where a startup launched into the wild, flailed badly, and recovered (without completely abandoning the first product). There are lots of examples of flailing and relaunching (see Cuil, see Joost), but I can’t think of anyone that managed to pull out a win. 
 By my count Color , the $41 million startup that promises to “transform the way people communicate with each other,” has already struck out. 
 The first strike was a launch that left users confused, sharing photos with themselves and trying to figure out a user interface that seemed purposely designed to frustrate. We gave them another chance . 
 Strike two: pulling the Android version of the app from the market. 
 And strike three: engaging in a big PR partnership with The Telegraph in the UK to get people all over the UK to post pictures during the royal wedding. Just 500 photos were posted , which isn’t much more than MG Siegler and friends managed to post during a bachelor party/iPhone fest in Mexico a few weeks ago. And The Telegraph promised that the best photos would be published. Here are those “best” photos. 
 This third strike was particularly egregious. The color team knows that people are confused about what the app is supposed to do. It’s not supposed to be just another photo sharing app. It’s about the future of social networks. I’m fully on board with the social network stuff, and have been waiting for it since 2008 . 
 So why in the world would Color, with a hamstrung app and a confused marketplace, pull a major PR stunt that’s all about showing off Color as exactly what the company doesn’t want Color to be thought of (another photo sharing app)? 
 You got me. If anyone gets it, let me know. 
 I want Color to succeed. I don’t hold their funding against them in any way. I love that they’re trying to solve a really big problem. And I like that the team is successful but still hungry. 
 But Color shouldn’t have launched when they did. They knew the app was seriously flawed, and they should have known that they probably wouldn’t get another chance at a first impression. And with all the negativity, the last thing they should have done was push the app as is to tens of millions of people in the UK. Those masses have far less patience for the quirks of unfinished software than people like us do. 
 The team here at TechCrunch will give Color all the mulligans it wants to get things right. They can swing and miss all day and we’ll still be here in the stands, rooting them on. But eventually the crowds, tired of boo’ing, will go home. And the stadium lights will go out. And then, even if Color hits one out of the park, we’re not sure there’ll be anyone around to see it. 
 I say to Color, “SWING for the fences!” Just don’t keep swinging with your eyes squeezed shut. 
 CrunchBase Information  Color Labs  Information provided by CrunchBase
Twitter recently upped its rates on Twitter Promoted Trends from $60K-$70K to between $100K-$120K which means the demand for the unique form of advertising is certainly there. But what are brands getting in return? As we've seen before with Skittles, Charlie Sheen , and even the #Dickbar, attempting to float a brand message over user generated Twitter content isn't always a success.
The Pitfall Of Twitter’s ‘Promoted Trends’ #RoyalWedding
Twitter recently upped its rates on Twitter Promoted Trends from $60K-$70K to between $100K-$120K which means the demand for the unique form of advertising is certainly there. But what are brands getting in return? As we’ve seen before with Skittles, Charlie Sheen , and even the #Dickbar, attempting to float a brand message over user generated Twitter content isn’t always a success. 
 Case in point … For the past few days the chatter around the #RoyalWedding has been plentiful, but not necessarily all positive. 
 Diet shake Slim Fast bought the #RoyalWedding Promoted Trends slot yesterday, and at some point had its brand message (and its inexplicable link to its Facebook page) associated with sundry undesirable content. 
 While granted it is sort of funny, the relevancy of tweets like “#RoyalWedding of the ass is my c*ck” to Slim Fast’s admittedly inane message should be a serious issue for a company trying to monetize UGC. Companies who spend money on advertising tend to avoid the above sorts of associations, with good reason. 
 What makes this specific instance of ad relevancy failure worse is that the #RoyalWedding hashtag is currently being highlighted on Twitter’s revamped homepage along with #STS134 and #NFLDraft — As things that presumably add value to new Twitter users. Right now all three are riddled with hashtag spam. 
 Twitter, which just hit 200 million users , is currently averaging about 500K new accounts a day. While this growth isn’t too shabby, it’s hard to picture the middle aged, middle American curious about Twitter landing on the above results and wanting to stick around for very long. 
 #RoyalWedding side note: Twitter did not have a whole server dedicated to Will & Kate today. That was a joke. 
 CrunchBase Information  Twitter  Information provided by CrunchBase
Last week President Obama spoke at Facebook , emphasizing during the townhall that the US needs to be bullish on Science and Math education if we are to pull out of the recession, "We want to start making Science cool. I want people to feel about the next big energy breakthrough and the next big Internet breakthrough the same way they felt about the moonwalk,” he said.

Taking off on that idea, Nancy Conrad, the wife of late astronaut Pete Conrad, has founded the Conrad Foundation in the memory of her husband. Pete Conrad was expelled from one school in the 11th grade because he had dislexia and then went on to graduate from Princeton and walk on the moon because he was taken under the wing of an educator who saw promise in the young man.
Nancy Conrad On Education Innovation: Turning Geeks Into Rock Stars Is A Game Changer
Last week President Obama spoke at Facebook , emphasizing during the townhall that the US needs to be bullish on Science and Math education if we are to pull out of the recession, “We want to start making Science cool. I want people to feel about the next big energy breakthrough and the next big Internet breakthrough the same way they felt about the moonwalk,” he said. 
 Taking off on that idea, Nancy Conrad, the wife of late astronaut Pete Conrad , has founded the Conrad Foundation in the memory of her husband. Peter was expelled from one school in the 11th grade because he had dyslexia and then went on to graduate from Princeton and walk on the moon because he was taken under the wing of another educator who saw promise in the young man. 
 Nancy Conrad wants to give other kids with a penchant for entrepreneurship their “moon shots,” or the opportunity to get funding and actualize their ideas; Because of this the Conrad Foundation puts on the Spirit of Innovation Awards and Innovation Summit annually, attempting to foster a love of innovation in kids between the ages of 13 and 18. 
 To attend the Innovation Summit , high schoolers across the country are invited to enter the three year old competition, which ends up flying in 27 finalists to NASA Ames to pitch their startups to judges in one of three categories: Aerospace Exploration, Clean Energy and Cyber Security. The winning team in each category receives a 5K grant to fund their project. 
 While building the “innovative workforce of the 21st century” is an ambitious goal, after attending the extremely professional finalist presentations today it’s obvious that spotlighting kids who have a passion for innovation and technology is a fundamental step in turning our education system around. 
 “There’s so many problems, we’re not running out of problems,” Conrad said emphasizing that you need to get kids excited about Science, Math and Technology in order build a viable workforce. “When you’ve got juiced kids who really want to do something, they don’t know there’s a box. And then all they do is think outside the box. This is where geeks turn into rockstars, and that’s the game changer. That’s where you can change the culture of students.” 
 Hmm … So maybe Intel was right ?
This week, the U.S. Environmental Protection Agency issued Energy Star ratings for large vat commercial fryers . These appliances are used by high-volume dining establishments — like fast food chains, institutional cafeterias and full-service restaurants— to make french fries, hush puppies and anything else Paula Deen would promote, in bulk.

Encouraging the industry to upgrade to more energy-efficient fryers could help reduce the overall environmental (if not health) impact of kitchens in the U.S. catering to the collective appetite for fried foods, an appetite that seems pervasive, and permanent here. One Texan cook, Mark Zable, has even invented a method to make deep-fried beer . 

According to a press statement and calculations by the EPA...
Can I Get Some Sustainability With That Shake?
This week, the U.S. Environmental Protection Agency issued Energy Star ratings for large vat commercial fryers . These appliances are used by high-volume dining establishments — like fast food chains, institutional cafeterias and full-service restaurants— to make french fries, hush puppies and anything else Paula Deen would promote, in bulk. 
 Encouraging the industry to upgrade to more energy-efficient fryers could help reduce the overall environmental (if not health) impact of kitchens in the U.S. catering to the collective appetite for fried foods, an appetite that seems pervasive, and permanent here. One Texan cook, Mark Zable, has even invented a method to make deep-fried beer . 
 According to a press statement and calculations by the EPA: 
 ” If every large vat fryer in the [country] met the new Energy Star requirements, energy cost savings would increase approximately $81 million per year and reduce annual greenhouse gas emissions equivalent to the emissions from nearly 95,000 cars.”
 
 The lifetime costs and footprint of commercial frying goes beyond the electricity and gas that it takes to run kitchen equipment, of course. Certain vegetable oils are more sustainable than others. Spent grease, and even vegetable oil, can become a pollutant unless disposed of properly. 
 Many food businesses are opting to give or sell their spent grease to biofuel producers, these days, thankfully. 
 Bon Appétit Management Company — which provides sustainable food in cafes at SF Giants stadium, eBay, Oracle, Google and college campuses including U-Penn, Duke and MIT — has been doing this for years, in collaboration with local biofuel companies like Kelley Green Biofuel for example. 
 This month (as Tilde Herrera reported for Greenbiz.com) U.S. Foodservice went so far as to acquire a “grease diesel” company, WVO Industries. The foodservice business will begin to power its truck fleets with their own spent cooking oil, allowing them to avoid the rising costs of gasoline here. 
 Ultimately, foods that are sautéed, boiled, toasted, roasted or prepared raw will prove better for the body and planet than deep-fried with rare — no pun intended — exception. 
 There is no official carbon footprint label for food here, but a sustainability blogger and small business owner in Germany, Peter Graf (not to be confused with Peter Graf, chief sustainability officer at SAP) has shared some rough calculations via his blog Ecofriendly-Company.com . He wrote: 
 “The path from potato to french fry takes 9 steps.The potatoes are… 
 
 1. Steamed and peeled, 
 2. Cut 
 3. Blanched 
 4. Dried 
 5. Par-fried 
 6. Cooled 
 7. Frozen 
 8. Transported 
 9. Stored frozen
 
 Then, they’re fried in hot oil in the canteen and served. All this transforms a single kilo of potatoes (140g CO2) into a real climate-killer (5700g CO2).” 
 Photo courtesy Brandi Jordan (CC-2.0) 
 
 CrunchBase Information  U.S. Environmental Protection Agency  Kelley Green Biofuel  Information provided by CrunchBase
Square founder and CEO Jack Dorsey just tweeted a photo of the company's internal dashboard, and, aside from looking very sexy, it's boasting some impressive numbers. Among them: Square has shipped 341,688 of its card readers to date and has 332,483 activated users.

As Dorsey's tweet points out, Square is also showing some very impressive growth: on March 2, Square was processing $1 million per day. Now, less than two months later, it's doubled that, with $2 million in processed payments today (and there's still some time left on the clock).
Jack Dorsey Shares Some Big Square Numbers: 341,688 Readers Shipped, $137M Total Flow
Square founder and CEO Jack Dorsey just tweeted a photo of the company’s internal dashboard, and, aside from looking very sexy, it’s boasting some impressive numbers. Among them: Square has shipped 341,688 of its card readers to date and has 332,483 activated users. 
 As Dorsey’s tweet points out, Square is also showing some very impressive growth: on March 2, Square was processing $1 million per day. Now, less than two months later, it’s doubled that, with $2 million in processed payments today alone (and there’s still some time left on the clock). 
 Other stats on the dashboard: Square’s total flow to date, which I believe means the total amount of transactions it’s done, is just shy of $137 million. Its revenue for today is $59,390,  a 40% increase since last Friday. It’s unclear what drove the huge gain over last week — perhaps Square’s  availability  in Apple retail stores is contributing to the growth spurt. 
 Update : More stats — it’s a little hard to read, but it looks like Square might have 23,630 ‘Card Payments’ (which might be the number of transactions today). It also looks like they had 9,078 active users today (again, it’s a little hard to make out). I’ve included an image that has gone through our special CSI:Enhance filter below. 
 
 CrunchBase Information  Square  Information provided by CrunchBase
If you've ever worked in retail or the food services industry, you're probably familiar with the Point of Sale (POS) system. It's the software/hardware combination that most people would probably call a cash register, though there's more to it than that: inventory tracking, coupons, exchanges, and pretty much everything else is done using one of these POS systems. And they're often a total pain, with myriad options and interfaces that sometimes harken back to the Windows 3.1 days.

 Pose is one company (among many) that's trying to fix the POS. And instead of relying on a new hardware device, they're turning to one you already have: your web-connected computer. Everything on Pose is web-based, so you can easily set up a new terminal if one computer starts malfunctioning, and setup is obviously cheap because you probably don't have anything to buy.
Strike A Pose, ‘Cause Online Point Of Sale Systems Are The New Vogue
If you’ve ever worked in retail or the food services industry, you’re probably familiar with the Point of Sale (POS) system. It’s the software/hardware combination that most people would probably call a cash register, though there’s more to it than that: inventory tracking, coupons, exchanges, and pretty much everything else is done using one of these POS systems. And they’re often a total pain, with myriad options and interfaces that sometimes harken back to the Windows 3.1 days. 
 Pose is one company (among many) that’s trying to fix the POS. And instead of relying on a new hardware device, they’re turning to one you already have: your web-connected computer. Everything on Pose is web-based, so you can easily set up a new terminal if one computer starts malfunctioning, and setup is obviously cheap because you probably don’t have anything to buy. 
 I spoke with CEO Guy Marcus earlier this week, who walked me through a demo of the product. As with other POS systems, you can enter products manually or using a USB barcode scanner. You can then flip into the cashier interface, where you can input what the customer is purchasing by tapping on photos or, again, using a USB scanner. 
 Pose isn’t available to the public quite yet (they’re aiming for a June release), but from what I saw it looked solid — they’re putting a lot of work into making the interface usable and attractive. It’s also optimized for both desktop and tablet use. Businesses will pay for the web-based software as a monthly subscription. 
 Pose isn’t the first company to have this idea — competitors include Erply , VendHQ , Cashier Live , and MerchantOS . But Marcus says that his company differs from the others because it also integrates marketing functionality — customers can opt to provide their email addresses to receive receipts and future correspondence from the business. Pose will also allow merchants to generate an online storefront (it uses the same inventory as your retail database) in a matter of minutes. Merchants are still responsible for actually shipping these goods, though. 
 I also asked if Marcus saw Square —which has an iPad app that can be used to tally up a customer’s purchases — as a competitor. He says that he doesn’t think Square will be offering a deep inventory management system any time soon, and that he sees the payments company as more of a potential partner. 
 Pose’s four-person team is based in Israel. The company has raised $300K. 
 Disclosure: Roi Carthy, who sometimes submits articles from Israel, has invested in Pose through his VC fund. Roi isn’t a TechCrunch employee.
Well, the Royal Wedding is over. Wasn't that wonderful? If you weren't watching on TV, there were about a million ways to participate online . Millions watched on YouTube, Livestream and elsewhere. And even those who were there uploaded their own photos and videos, including this guy.  I'll call him the masked Union Jack freak. Is that some sort of S&M suit he's wearing? It doesn't seem proper juxtaposed with the royal newlyweds. 

You can find pictures of him on a special Color Royal Wedding Album created by people using the iPhone social camera app and sponsored by the British paper, The Telegraph. You remember Color, the $41 million photo app that created a huge backlash in the press and some confusion among consumers about exactly how to use the app.
The Creepiest Royal Wedding Photo Ever, Courtesy Of Color
Well, the Royal Wedding is over. Wasn’t that wonderful? If you weren’t watching on TV, there were about a million ways to participate online . Millions watched on YouTube, Livestream and elsewhere. And even those who were there uploaded their own photos and videos, including this guy.  I’ll call him the masked Union Jack freak. Is that some sort of S&M suit he’s wearing? It doesn’t seem proper juxtaposed with the royal newlyweds. 
 You can find pictures of him on a special Color Royal Wedding Album created by people using the iPhone social camera app and sponsored by the British paper, The Telegraph. You remember Color, the $41 million photo app that created a huge backlash in the press and some confusion among consumers about exactly how to use the app. 
 Yeah, well, even with the Telegraph pushing the app as some sort of crowd-sourced photo collage, only about 560 photos were uploaded to the album, and none of them are terribly interesting. But I guess you had to be there. 
 
 CrunchBase Information  Color Labs  Information provided by CrunchBase
"Online Services Division revenue grew 14% year-over-year primarily driven by increases in search revenue."

That was Microsoft's statement about the Online Services Division in their earnings release yesterday. Growth! Yippee! The strategy is working! Right?

Wrong.

What they don't bother to mention in the release, but they can't hide in the actual numbers, is just how bad the quarter actually was for the division. While revenue may have grown a bit year over year, income — as in the money you actually get to keep — was an entirely different story. It was a bloodbath, really. Yes, again.
When Will Microsoft’s Internet Bloodbath End?
“Online Services Division revenue grew 14% year-over-year primarily driven by increases in search revenue.” 
 That was Microsoft’s statement about the Online Services Division in their earnings release yesterday. Growth! Yippee! The strategy is working! Right? 
 Wrong. 
 What they don’t bother to mention in the release, but they can’t hide in the actual numbers, is just how bad the quarter actually was for the division. While revenue may have grown a bit year over year, income — as in the money you actually get to keep — was an entirely different story. It was a bloodbath, really. Yes, again. 
 Microsoft lost $726 million in the Online Services Division for the quarter. It was actually their worst quarter in two years in that regard. And it was their second worst ever, as Business Insider points out in their nifty chart perfect for showing such bloodbaths. 
 And despite the year over year revenue growth, the income was actually down year over year. As in, they managed to lose more money despite bringing in more. As in, the statement up top is total misdirection bullshit. 
 And how’s this for a kick in the pants: if Microsoft had just scrapped their Online Services Division for the quarter, they likely would have beaten Apple in terms of profits once again. Instead, they’re over $700 million behind — behind, mind you, for the first time in a couple decades. 
 Of course, Microsoft can’t afford to scrap the Online Services Division (well, figuratively afford it, at least). Like every technology company, they know this is the key to the future. And that’s precisely why they’re dumping so much money into it. 
 But it that strategy actually working? Revenue is growing, but losses are mounting. Microsoft is having to spend $2 to make $1 — actually a bit worse than that ratio! 
 Last October, I wrote that Microsoft was running basically the worst Internet startup ever . This pissed a lot of people off, who thought the comparison was unfair. After all, Microsoft can afford to burn the money. 
 That’s true, the quarter overall was fairly good for them (though the stock took a nosedive today because it wasn’t good enough). But if the two pillars of their business, Windows and Office, start to slip (as just about everyone believes they will sooner or later as we move into an increasingly mobile world of computing), these Online Services losses are going to become a big, big problem. Fast. 
 Maybe Microsoft can figure it out before that happens. But there’s just absolutely no data pointing in that direction right now. And there hasn’t been in the past six years . In fact, the numbers are actually getting worse! 
 After a nightmare Q3 and Q4 in 2010 (fiscal, not the actual calendar quarters) with Online Services loses right around $700 million, it looked like Microsoft may be turning things around with loses of “only” around $550 million in Q1 and Q2 of 2011. But if you look at the bigger picture, you’ll see that those Q1 and Q2 loses were actually worse year over year. If you simply extrapolated that out, you should have been able to predict this quarter’s bloodbath as well. 
 In the past year, Microsoft has now lost a staggering $2.5 billion in the Online Services Division. Think about that for a second. When I wrote the October post, the loss runrate was “only” $2 billion. The situation is getting worse. 
 And so I ask, how long can this bloodbath last? When will it end? Or maybe more to the point: will it end? All the data we have right now points to a pretty definitive “no”. 
 
 [image: New Lines Cinemas] 
 CrunchBase Information  Microsoft  Information provided by CrunchBase
Vibrating sex toys have been around for over a century, starting out as crude  steam powered devices and now resembling something very cool that you might pick up at an Apple store. Sex toys have been the source of giggles, controversy, pleasure and up until the last 5 years, were not a mainstream product. They were devices you bought and had shipped in unmarked brown packaging or slipped into a toy store late at night to buy, but were not something you'd ever imagine picking up at Nordstrom or your local Wal-Mart .

Millions of men and women use them every day and yet, it isn't something we talk about much. Considering there's a lot of tech that go into these devices these days, I think it is a topic worth exploring and definitely something we should no longer be ashamed of.
Speaking of… sex toys with Ethan Imboden from Jimmyjane [TCTV]
Vibrating sex toys have been around for over a century, starting out as crude  steam powered devices and now resembling something very cool that you might pick up at an Apple store. Sex toys have been the source of giggles, controversy, pleasure and up until the last 5 years, were not a mainstream product. They were devices you bought and had shipped in unmarked brown packaging or slipped into a toy store late at night to buy, but were not something you’d ever imagine picking up at Nordstrom or your local Wal-Mart . 
 Millions of men and women use them every day and yet, it isn’t something we talk about much. Considering there’s a lot of tech that go into these devices these days, I think it is a topic worth exploring and definitely something we should no longer be ashamed of. 
 Today’s episode of Speaking Of covers the journey of an amazingly brave entrepreneur, Ethan Imboden , Chairman of Jimmyjane , who set out to design something meaningful that would change people’s lives. He’s not the first to create a stigma free product. Many cool products have been sold in stores like Good Vibrations for years, but he’s the first to bring a safe, non-toxic, sexy, virtually stigma free brand to the mainstream market. His efforts were what I consider truly disruptive and changed the landscape for the availability of pleasure toys for consumers everywhere. I’ll never forget the day I saw one of his products in a local lingerie store and how I started stumbling into them at mainstream stores everywhere. Seeing these products available to people in comfortable settings brought me so much joy and I’m excited to be able to share his journey into creating such a wonderful product with all of you. 
 Ethan shares his journey of starting out as an electrical engineer, becoming a designer for Herman Miller and how he was encouraged to start revolutionizing the sex toy space. We learn about him as a DJ, world-traveler and the fact that his arch nemesis designer was the guy who designed Swingline staplers. At the end of the episode, we get a tour of some of his products that are quite stimulating to look at and at the time of the interview, he hinted at the launch of their new Form 4 product, which is now available . 
 We have one product giveaway for commenters. Best, most insightful comment on the sex toy industry wins one of Jimmyjane’s awesome products that they gave to us in the studio. The deadline is Sunday 6pm PT. You must be 18 years old to win. 
 
 
 Ethan Imboden – Photo credit: Laist.com
As we saw from retailer JC Penney's recent downfall in search rankings, using ' black hat' SEO tactics and gaming search is considered deceptive and 'tantamount to cheating' by Google. J.C. Penney said that it had no idea that this was happening and fired its SEM agency right away. But the retailer's search ranking had already been "adjusted" by Google, and the damage was done. These sort of situations are considered deceitful by many in the search industry (including Google) and generally cast a malevolent cloud over a company's search tactics. So, it's surprising to find that a Sequoia Capital -backed Chinese startup, called Milanoo , appears to be gaming Google search results with these same black hat links spam tactics.

Milanoo, a China-based online retailer and wholesaler with a “passion for fashion,” is an ecommerce company serves customers with fashion apparel and related products in over 180 countries around the world, in seven languages (including English, Spanish and French). Launched in 2008, the startup just raised "millions of dollars" from Sequoia. According Digital Due Diligence, a small agency that provides in-depth investment research into online assets of companies; Milanoo has been caught using similar tactics as J.C. Penney.
Sequoia-Backed Milanoo Appears To Be Gaming Search Results With Link Spam
As we saw from retailer JC Penney’s recent downfall in search rankings, using ‘ black hat’ SEO tactics and gaming search is considered deceptive and ‘tantamount to cheating’ by Google. J.C. Penney said that it had no idea that this was happening and fired its SEM agency right away. But the retailer’s search ranking had already been “adjusted” by Google, and the damage was done. These sort of situations are considered deceitful by many in the search industry (including Google) and generally cast a malevolent cloud over a company’s search tactics. So, it’s surprising to find that a Sequoia Capital -backed Chinese startup, called Milanoo , appears to be gaming Google search results with these same black hat links spam tactics. 
 Milanoo, a China-based online retailer and wholesaler with a “passion for fashion,” is an ecommerce company serves customers with fashion apparel and related products in over 180 countries around the world, in seven languages (including English, Spanish and French). Launched in 2008, the startup just raised “millions of dollars” from Sequoia. According Digital Due Diligence, a small agency that provides in-depth investment research into online assets of companies; Milanoo has been caught using similar tactics as J.C. Penney. 
 Here’s what Digital Due Diligence found: For a number of very valuable keywords in Google search,, Here’s how Milanoo ranks for “cheap dresses” (position 2), “evening gown” (1), “cheap wedding dresses” (1), and “summer dresses” (2). Digital Due Diligence partner Doug Pierce (who also served as an expert in the New York Times J.C. Penney expose), writes that those four keywords alone have an equivalent cost of nearly $200,000 per month in Google AdWords. 
 It’s a red flag, explains Pierce’s fellow partner Byrne Hobart, when a search for evening gown or summer dress results with Milanoo as the second highest result as opposed to a major retail brand, like Macy’s Saks, Dillards, the Gap etc. In full disclosure, I am an avid online shopper and despite the company being in operation for three years, had never heard of Milanoo until it was covered on a TechCrunch a few weeks ago. So it is a little surprising to see that the site is listed as the second result in a search for the term “evening gown” under Bluefly, a site which I frequently visit. 
 This could indicate that Milanoo may be paying for spam and links to boost their ranking, which Google considers to be deceptive. Basically, Google’s algorithm considers and counts ingoing links to pages as a way to determine search rank. The more links a website collects, the higher it could rank. Google of course attempts to determine the source of these links, but in some cases, this can be overlooked. 
 In the situation with Overstock.com (who Google put in a penalty box for gaming search results), the retail site was paying for inbound links from Edu addresses, which Google tends to consider as more authoritative. In the case with J.C. Penney, many of the links to the retailers site were from spammy sites, where the company paid for these sites to link to the retailers for keywords like “evening dresses.” For example, a fashion blog linking to a retailer is fair. A Bulgarian property portal link is not. 
 Basically, Milanoo appears to be doing the same thing as J.C. Penney. The ecommerce site has been buying spammy links to both its homepage as well as to individual product pages, and these sites have linked, thus boosting Milanoo’s ranking above other, more well-known retailers in Google search. 
 Using the Open Site Explorer tool from SEOMoz, Hobart and Pierce say they couldn’t find a single inbound link that points to the page that isn’t spam or paid for. We too took a look at Open Site Explorer, searched for Milanoo’s link to “Evening Gown,” and found incoming links from NicePromOnline. Ok, so these aren’t as far fetches as J.C. Penney, but spammy sites nonetheless. 
 Then I did a search on Open Site Explorer for the link to Cheap Wedding Dresses on Milanoo, which resulted in inbound links from NFL New Jerseys, Auto News. Wow. Looks like Milanoo may have been caught red-handed in link exploitation. 
 So it’s a little surprising that Sequoia, a top-tier venture capital firm, would invest in a company that is using underhanded tactics to game Google’s search algorithm. And ironically, Sequoia is an early investor in Google. Pierce tells us that many times, investors don’t do the sort of in-depth digital due diligence that would flag these types of issues. His company is trying to provide investors with the tools and services to prevent situations like this. 
 If Google does find that Milanoo is gaming it’s search algorithm, the punishment can not only be damaging to a company’s search results, and brand but also to their top line. Overstock penalty by Google, which resulted in lower search rankings on the search engine hurt sales by 5 percent during the penalty period. 
 Similar to Overstock and J.C. Penney, a steady flow of visitors is key to Milanoo’s ecommerce business. And search is clearly a way to get those visitors.
The speakers for Disrupt just keep on getting better and better. Today, we are extremely excited to announce four more guests who will join us at this year's Disrupt in New York City: Marissa Mayer, David Karp, Kevin Systrom, and Tony Conrad.

Marissa Mayer joined Google in 1999 as Google's first female engineer. She ran the search product for years and is now the VP of Local & Maps at Google. Mayer will be one of the finalist judges at the Startup Battlefield. She's tough, she's done it before, and we are grateful to have her back.

David Karp is the CEO and founder of Tumblr, one of the hottest startups in New York and also one of fastest-growing websites , period. Tumblr is built on the principle that self-expression should be easy. Karp recently raised $30 million to keep up with all the growth.
Marissa Mayer, David Karp, Kevin Systrom, And Tony Conrad Will Rock At Disrupt NYC
The speakers for Disrupt just keep on getting better and better. Today, we are extremely excited to announce four more guests who will join us at this year’s Disrupt in New York City: Marissa Mayer, David Karp, Kevin Systrom, and Tony Conrad. 
 Marissa Mayer joined Google in 1999 as Google’s first female engineer. She ran the search product for years and is now the VP of Local & Maps at Google. Mayer will be one of the finalist judges at the Startup Battlefield. She’s tough, she’s done it before, and we are grateful to have her back. 
 David Karp is the CEO and founder of Tumblr, one of the hottest startups in New York and also one of fastest-growing websites , period. Tumblr is built on the principle that self-expression should be easy. Karp recently raised $30 million to keep up with all the growth. 
 Kevin Systrom also knows a thing or two about hockey-stick growth, but at an earlier stage than Tumblr and on mobile. Systrom is a co-founder of Instagram, an incredibly popular photo sharing application for the iPhone. Instagram took only 6 weeks to pass 2 million users and shortly after was adding an estimated 130,000 users per week . 
 Finally, Tony Conrad is the CEO and co-founder of about.me, which was acquired by AOL is December of 2010. Tony is a Founding Venture Partner at True Ventures where he serves on the Board of Directors of Automattic, appssavvy, StockTwits, and more. He is also a Special Advisor to AOL Ventures. 
 As we get closer to Disrupt NYC 2011, we are going to keep announcing new guest speakers week after week. You can read the full list of announced speakers here . If you haven’t purchased a ticket already, you can do so here. Early bird ticket prices end April 30th at midnight PST, so if you want the best prices, make sure to purchase them soon. 
 Disrupt in NYC is going to be big. We have taken over a Pier 94 , we are planning amazing after parties, and we have more surprises in store. If you’d like to become a part of the Disrupt experience and learn about sponsorship opportunities, please contact Jeanne Logozzo or Heather Harde for more information. 
 
  Marissa Mayer 
Vice President of Location and Local Services, Google 
 Marissa Mayer is the Vice President of Local & Maps at Google. Previously she was Vice President of Search Product and User Experience. Mayer joined Google in 1999 as Google’s first female engineer, where she led the user interface and web server teams at that time. Her efforts have included designing and developing Google’s search interface, internationalizing the site to more than 100 languages, defining Google News, Gmail, and Orkut, and launching more than 100 features and products on Google.com. Prior to joining Google, Mayer worked at the UBS research lab (Ubilab) in Zurich, Switzerland, and at SRI International in Menlo Park, California. Mayer has been featured in various publications, including Newsweek (“10 Tech Leaders of the Future”), Red Herring (“15 Women to Watch”), Business 2.0 (“Silicon Valley Dream Team”), BusinessWeek, Fortune, and Fast Company. 
 
  Tony Conrad 
CEO & Co-founder, about.me 
 Tony Conrad is CEO & co-founder of about.me (acquired by AOL in December 2010). He is also a Founding Venture Partner at True Ventures where he serves on the Board of Directors of Automattic (WordPress), appssavvy, StockTwits, RescueTime, PastFuture (GDGT), KISSmetrics, 20×200, FREEjit, Small Batch (Typekit), WeGame and led True’s investment MakerBot & Plancast. Tony also serves as a Special Advisor to AOL Ventures. Previously, Tony co-founded Sphere which was acquired by AOL in April, 2008. In addition, Tony has served on the Board of Directors for Oddpost (acquired by Yahoo), Iconoculture, MusicNow (acquired by Circuit City), and Centive (acquired by Xactly). Tony also played an active role managing investments in Post Communications (NASDAQ: NTVS), QuinStreet (NASDAQ: QNST), Danger (acquired by Microsoft), Sabrix and Stonyfield Farms (acquired by Groupe Danone). 
 
  David Karp 
Founder & CEO, Tumblr 
 David Karp is a high school dropout and the founder and CEO of Tumblr. Karp grew up on the Upper West Side of Manhattan, the son of Barbara Ackerman and Michael Karp. He attended The Calhoun School from 3rd to 8th grade, where his mother taught science, until high school when he briefly attended Bronx Science before dropping out at the age of 15 and being homeschooled. Karp began interning for animation producer Fred Seibert at 14, and from there went on to work as a software consultant for UrbanBaby, an online parenting forum. Karp left UrbanBaby in 2006 and began working on Tumblr later that year. The site launched early in 2007. 
 
  Kevin Systrom 
Co-founder, Instagram 
 Kevin Systrom is a co-founder of Instagram, a photo sharing application for the iPhone. He also founded Burbn, an HTML5-based location sharing service. Kevin graduated from Stanford University in 2006 with a BS in Management Science & Engineering. He was an intern at Odeo that later became Twitter. He spent two years at Google, the first working on Gmail, Google Reader, and other products and the latter where he worked on the Corporate Development team.
Here is another chance to win a free ticket to this year's Disrupt in NYC. . We have announced some amazing guests and speakers for this year's Disrupt and we will be announcing more later on today. Tim Armstrong, Arianna Huffington, Ron Conway, Dennis Crowley, and Chris Dixon will all be joining us, just to name a few. For now, you can check out the full list of speakers and guests here . As you know, we will be taking over Pier 94 , overlooking the Hudson River in west Midtown Manhattan. However, not only are we taking over a pier, we are also taking over some amazing spots in New York City for the after parties. We also have other special surprises we will announce as we get closer. A special congratulations to Adam Growald for winning last week's ticket.

Disrupt is happening May 23rd to May 25th in New York City and we want you to come with us. To win this week's free ticket, all you have to do is follow the steps below.
TechCrunch Giveaway: A Free Ticket To Disrupt NYC #TechCrunch
Here is another chance to win a free ticket to this year’s Disrupt in NYC. We have announced some amazing guests and speakers for this year’s Disrupt and we will be announcing more later on today. Tim Armstrong, Arianna Huffington, Ron Conway, Dennis Crowley, and Chris Dixon will all be joining us, just to name a few. For now, you can check out the full list of speakers and guests here . As you know, we will be taking over Pier 94 , overlooking the Hudson River in west Midtown Manhattan. However, not only are we taking over a pier, we are also taking over some amazing spots in New York City for the after parties. We also have other special surprises we will announce as we get closer. A special congratulations to Adam Growald for winning last week’s ticket. 
 Disrupt is happening May 23rd to May 25th in New York City and we want you to come with us. To win this week’s free ticket, all you have to do is follow the steps below. 
 1) Like our TechCrunch Facebook Page: 

 2) Then do one of the following: 
 - Retweet this post (including the #TechCrunch hashtag) 
- Or leave us a comment below 
 The contest starts now and ends tomorrow, April 30th at 7:30pm PST. 
 Please only tweet the message once or you will be disqualified. We will make sure you follow the steps above, choose at random, and contact the winner this weekend with more details. Anyone in the world is eligible. 
 Please note this giveaway is for 1 ticket only and does not include airfare or hotel. 
 Good luck!
Nokia Siemens has closed the acquisition of the wireless network infrastructure assets of Motorola Solutions today. The company reports that it paid $975 million in cash for the assets and approximately 6900 employees will transfer to Nokia Siemens Network from Motorola. The finalization of the deal come after China regulators approved the acquisition a last week. The full release is paste below. 

As of April 30 2011, the company says that responsibility for supporting customers of Motorola Solutions’ GSM, CDMA, WCDMA, WiMAX and LTE products and services transfers to Nokia Siemens Networks. Part of the approval is due to the fact that Motorola reached an agreement with Chinese manufacturer Huawei over a pending patent lawsuit relating to the assets being acquired. In January, Huawei filed a lawsuit to prevent Motorola from giving Nokia Siemens Huawei's IP information.
Nokia Siemens Closes $975M Acquisition Of Motorola Solutions’ Wireless Network Assets
Nokia Siemens has closed the acquisition of the wireless network infrastructure assets of Motorola Solutions today. The company reports that it paid $975 million in cash for the assets and approximately 6900 employees will transfer to Nokia Siemens Network from Motorola. The finalization of the deal come after China regulators approved the acquisition a last week. The full release is paste below. 
 As of April 30 2011, the company says that responsibility for supporting customers of Motorola Solutions’ GSM, CDMA, WCDMA, WiMAX and LTE products and services transfers to Nokia Siemens Networks. Part of the approval is due to the fact that Motorola reached an agreement with Chinese manufacturer Huawei over a pending patent lawsuit relating to the assets being acquired. In January, Huawei filed a lawsuit to prevent Motorola from giving Nokia Siemens Huawei’s IP information. 
 The litigation was recently settled for an undisclosed financial amount. 
 It’s been nearly a year since Nokia announced the acquisition of Motorola’s wireless assets. Back then, Nokia was planning to pay $1.2 billion for the network and the deal was predicted to close by year end. 
 Nokia says that based on revenue, the acquisition of Motorola Solutions’ Networks assets makes Nokia Siemens Networks the third largest wireless infrastructure vendor in the United States and the leading non-Japanese wireless vendor in Japan. And as part of the deal, Nokia Siemens Networks is acquiring a number of research and development facilities including sites in the United States, China, Russia, India and the UK. 
 Nokia Siemens Networks completes acquisition of certain wireless network infrastructure assets of Motorola Solutions 
Pays US $975 million in cash 
Approximately 6900 employees will transfer to Nokia Siemens Networks 
Takes on responsibility for 50 operator customers in 52 countries 
Nokia Siemens Networks and Motorola Solutions, Inc. (NYSE: MSI) today jointly announced that Nokia Siemens Networks has completed its acquisition of Motorola Solutions’ Networks assets paying US $975 million in cash. As of April 30 2011, responsibility for supporting customers of Motorola Solutions’ GSM, CDMA, WCDMA, WiMAX and LTE products and services transfers to Nokia Siemens Networks. 
 “The people, customers and technology we’ve acquired greatly complement our existing business by taking us into new markets and broadening our market share,” said Rajeev Suri, chief executive officer, Nokia Siemens Networks. “Our combined knowledge and experience will provide our newly expanded customer base with the means to grow by providing greater value to their subscribers.” 
 “Motorola Solutions is pleased to complete this transaction to combine our Networks team with an industry leader,” said Greg Brown, president and chief executive officer, Motorola Solutions. “This is great news for our customers, our investors and our people and will allow Motorola Solutions to further sharpen our strategic focus on providing mission-critical solutions for our government and enterprise customers.” 
 The acquisition strengthens Nokia Siemens Networks’ position in key regions, particularly North America and Japan, as well as with some of the world’s major service providers. Based on revenue, the addition of Motorola Solutions’ Networks assets makes Nokia Siemens Networks the third largest wireless infrastructure vendor in the United States and the leading non-Japanese wireless vendor in Japan. In addition, the acquisition reinforces Nokia Siemens Networks’ position as the world’s second largest wireless infrastructure and services provider. 
 As part of the deal, responsibility for supporting 50 operators across 52 countries, as well as approximately 6900 employees, will transfer to Nokia Siemens Networks. In addition, Nokia Siemens Networks is acquiring a number of research and development facilities including sites in the United States, China, Russia, India and the UK. 
 CrunchBase Information  Nokia  Information provided by CrunchBase
AudioMicro , a site where you can find royalty-free stock music and sound effects backed by DFJ Frontier and Fotolia , has struck a deal with Microsoft to provide music and sound effect files to Microsoft Office 2010 users worldwide.

Under the terms of the licensing and distribution deal, Microsoft Office 2010 users are able to select from a hand-picked collection of over 1,500 music tracks and sound effects at Office.com to use with any Microsoft Office project.
AudioMicro Partners With Microsoft: Free Music, Sound Effects For Office 2010 Users
AudioMicro , a site where you can find royalty-free stock music and sound effects backed by DFJ Frontier and Fotolia , has struck a deal with Microsoft to provide music and sound effect files to Microsoft Office 2010 users worldwide. 
 Under the terms of the licensing and distribution deal, Microsoft Office 2010 users are able to select from a hand-picked collection of over 1,500 music tracks and sound effects at Office.com to use with any Microsoft Office project. 
 The partnership is noteworthy because AudioMicro launched in 2008 with a heavy emphasis on the needs of PowerPoint slideshow creators, AudioMicro founder and CEO Ryan Born says. 
 Royalty-free sound effects offered by AudioMicro on Office.com include parts of The Hollywood Edge sound effects library created by the sound editors of Soundelux , whose credits include such films as Unstoppable, Inglourious Basterds, The Bourne Ultimatum and Braveheart. 
 AudioMicro is not all about stock music and sound effects, by the way – the company operates a constantly growing network of digital content licensing marketplaces, including for cartoons , celebrity pictures , and tattoo flash . 
 The company also announced that it recently brought on Myspace VP Sean Percival as an advisor – he will be helping the young company out with all things SEO and social. 
 
 CrunchBase Information  AudioMicro  Microsoft  Information provided by CrunchBase
Matrix Partners , a US-based investment firm with additional offices in India and China, this morning announced that it has closed two new funds: Matrix Partners China II (at $350 million) and Matrix Partners India II (at $300 million). The funds bring the firm's total international assets under management to $650 million in China and $600 million in India. 

Matrix Partners established an India presence back in 2006 and has an experienced entrepreneur running its investment team there: Avnish Bajaj, co-founder and former CEO of India's largest online marketplace Baazee.com (acquired by eBay). The firm has been active in China since 2008.
Matrix Partners Closes $650 Million Funds To Invest More In China, India
Matrix Partners , a US-based investment firm with additional offices in India and China, this morning announced that it has closed two new funds: Matrix Partners China II (at $350 million) and Matrix Partners India II (at $300 million). The funds bring the firm’s total international assets under management to $650 million in China and $600 million in India. 
 Matrix Partners established an India presence back in 2006 and has an experienced entrepreneur running its investment team there: Avnish Bajaj, co-founder and former CEO of India’s largest online marketplace Baazee.com (acquired by eBay). 
 The firm has been active in China since 2008. 
 Matrix was an active player in the development of the VC industry in the 1980s. The firm’s predecessor, Hellman Ferri Investment Associates, was founded by Paul J. Ferri and Warren Hellman (founder of San Francisco-based PE firm Hellman & Friedman). 
 Matrix Partners was an early stage investor in companies like Apple, JBoss, SanDisk, Tivoli Software and VERITAS Software. Recent investments include Anjuke , HubSpot , Zendesk , Care.com , GOGII , BuyWithMe , Gilt Groupe and Zong . 
 CrunchBase Information  Matrix Partners  Information provided by CrunchBase
Editor’s Note: This is a guest post by Mark Suster ( @msuster ), a 2x entrepreneur, now VC at  GRP Partners . Read more about Suster at  Bothsidesofthetable 

Banner Ads. They first started in 1994 and are therefore almost as old as the Web itself. They were very effective back then, with the original ad garnering a 78% click-through rate (CTR)! I guess from there we had nowhere to go but down.

Nowadays banner ads get on average 0.2% CTR meaning for every 1,000 ads that are served up only 2 people click on them. And as Jon Steinberg of Buzzfeed points out, the CTRs for social media banner ads are just 0.08%. Holy Shiitake!
The Future of Advertising Will Be Integrated
Editor’s Note: This is a guest post by Mark Suster ( @msuster ) a VC at  GRP Partners . He blogs at  BothSidesoftheTable . 
 Banner Ads. They first started in 1994 and are therefore almost as old as the Web itself. They were very effective back then, with the original ad garnering a 78% click-through rate (CTR) !  I guess from there we had nowhere to go but down. 
 Nowadays  banner ads get on average 0.2% CTR meaning for every 1,000 ads that are served up only 2 people click on them. And as Jon Steinberg of Buzzfeed points out, the CTRs for social media banner ads are just 0.08% . 
 Holy Shiitake ! 
 Despite its creation more than 15 years ago, banner ads have been surprisingly resilient despite their lack of efficacy. In the IAB study that revealed the graph above, brand advertisers indicated that their number one objective in online advertising was “creating awareness” followed by “creating purchase intent” or “likelihood to recommend” the product. Yet these seem to be the least effective attributes of banner advertising. 
 The fundamental problem with banner ads is a condition called “banner blindness” meaning that our eyes are really quickly trained to look at what is most relevant on the page – the content we want to see. Check out this chart from eye-tracking research conducted by the usability guru Jakob Nielsen published in this piece . It shows that our eyes are trained to focus on the text, not the ads. 
 I’m sure it probably resonants with how most of you read the web. 
 So I’ve spent the last few years checking out companies that are trying to solve for this problem. The global advertising market is estimated at around $475 billion / year with only 12% of this online and measurable. (some data sources have this estimate much higher.) We believe that the structural industry changes will continue to create big opportunities for technology firms that enable the changes in media consumption for television, radio, inbound calls, online & social media. We are investing heavily in these changes. 
 One company that  I previously wrote about trying to change this industry is, Solve Media , (I am not an investor) has created an interesting ad unit designed to drive up brand “engagement” and recall. The idea is that if I can serve you an ad for a function that you already need to perform on the web anyways – a captcha – with a brand message I can drive recall. And market research seems to confirm this. 
 You’ll see a clear problem here. Traditional banner ads only drive 16% brand recall and almost ZERO message recall. So it’s hard to argue that brands shouldn’t worry about CTR rates when it doesn’t seem that banners are very effective for branded advertising or awareness either. 
 It’s no big surprise that the overwhelming majority of online spend has therefore been “direct response” advertisements (trying to elicit an action) rather than branded advertising as pointed out in this good summary by Jeremy Liew . 
 So people will spend money online to get you to sign up for credit cards or Netflix but not to change your laundry detergent. I decided to look up one branded company in the chocolate segment to get a sense for the magnitude of spend online. Hershey’s chocolates spends about $365 million in advertising per year. Just $460,000 of this is spend on online display ads (0.1% for those without a calculator handy). 
 The reality is that advertising has got to become more integrated with content in order to drive efficacy. I know that any time ads are mentioned it makes the blood boil on any self respecting technologist the same way it did when HotWire ran their first ad in 1994 and the way it made Google’s blood boil when Overture launched the sponsored search category. 
 Ask anybody if they like product placements in movies or TV and they’ll resoundingly tell you “no” but marketers know better, which is why the celebrity endorsement industry is a $50 billion industry. 
 But even for the consumer reality sets in. Firstly, we care more about getting cheap or free high-quality media than we do about whether we see ads. Give people massive price increases on most media and they’ll abandon it. So how people behave and what they verbally say they stand for are often at odds. 
 Integrated Advertising 
 I believe that “integrated advertising” is one of the more effective types of advertising out there. You have to find a way to get your audience to actually “engage” with the content in the way that Solve Media is doing, in the way that in-game advertising works for video games or the way that celebrity endorsements work. 
 It’s why I still believe passionate in companies like Adly (I’m an investor) who have created ways for celebrities to integrate endorsements “in stream” in a Twitter feed. Yes. Oh, sacred cow. In the stream. Integrated with where our eyes & attention are. I advocated strongly for this 18 months ago and my belief system is as ardent as it was back then. If you’re interested here is my case . 
 But the simple facts are: 
 
 Our attention is all in the stream. As evidenced by the eye-tracking studies – they will remain in the stream. 
 We know that celebrity endorsement works. It has for decades. Celebrities care about their personal brands so will naturally rebuff requests to sponsor inauthentic products. 
 The beauty of social media is that consumers can vote with their “unfollow button” so it has a natural self-correcting mechanism. If you get economic value out of having followers you don’t want to lose them over one ad. 
 Sure, there needs to be ad disclosure. And naturally we have built in quality controls like: frequency capping, automated measurement so we can pull ads that people respond poorly to, A/B testing tools, data analysis to tell celebrities & brands which products will resonate, etc. 
 
 But I can tell you as my firm invested in Overture who created the category of pay-per-search that Google perfected – our company underwent three years of ridicule in Silicon Valley until people looked at the performance data and realized that efficacy matters. 
 The technology blogs will be aflutter with continued criticisms of in-stream ads while mainstream consumers continue to click on links provided by the celebrities they respect and will buy products accordingly. We already have the data that proves it. 
 In Image Ads 
 Another areas that I’ve been really focused on over the past 2 years is “in-image ads” as another form of integrated media. When you think about the eye-tracking we know that people care about the story and the images. And it is already an accepted fact that in many cases the ads & images are blended as any lady who reads Cosmo or Vogue will tell you. The big splashy image ads is part of their reading experience. 
 So we put our money where our mouth was an invested in the largest in-image advertiser on the web, GumGum , whose network now reached over 100 million monthly uniques with 3 billion ad-compliant images, delivering an average CTR of 0.4% (2x industry average for banners). The eyes are in the image. We believe this is why Google Ventures invested in Pixazza . 
 As you can see from this image, the ad is unobtrusive and potentially valuable to the reader. The ad unit is served up based on algorithms that determine what is actually in the image and also for whether an ad placement would impair the image. We could even target ads better based on who the end consumer was. 
 What else is out there in the field of integrated advertising? 
 Vibrant Media & Kontera have both built large and fast-growing businesses around text-based advertising and there are new entrants doing it in new ways like SkimLinks . Vibrant has a reach of 250 million uniques, making in the 12th largest ad-focused property online and has 3rd-party verified studies suggesting up to 50% increase in brand lift following their in-text ads (I’m not an investor in any of these companies). Text is shown to deliver higher CTRs than banners. Text is what we’re reading. It’s integrated. 
 There is a whole industry being spawned in the Internet video world and especially in the integration of devices (second screen TVs) and the TV experience. Some of the interactive experiences I’ve seen in recent demos are simply mind boggling and are starting to form new opinions in my head about how we will consume big screen TV in the future (I’ll save that for a future post). 
 The games industry has massively changed over the past several years to more of an integrated advertising / purchasing media with the growth of virtual goods and ads. An obvious example of integrated media would be the new Rio Angry Birds version. It’s actually very cool. There are increasingly incentivized offers to get more powerful swords & shields in battle games. This has proved far more effective than small crappy banners at the bottom of each screen. 
 There will always be a tension between advertising wanting to reach audiences through whatever means they can to capture their attention and help them discover new products and consumers who claim a strong preference for ad-free products. Yet the other tension between ad-free products that cost more versus ad-supported models have a clear winner: ads. On products where I’ve seen data the “ad free” versions have converted at 4-6% of the user base at maximum. 
 So the future of helping make the ad industry more measurable (and more online) I believe will be one of helping make ads both authentic & integrated. Trying to relegate ads to the least intrusive real estate of our computers is missing the point. Advertisers pay for efficacy. 
 If not, we’d be telling advertisers to just leave all of their branded advertising spend on traditional television in the future. And to stick with their old adage, “Half the money I spend on advertising is wasted. The problem is, I don’t know which half.”
Two California residents, Drew Moss and Sahar Maleksaeedi, have filed a rather peculiar class action lawsuit against Twitter (see documents embedded below). 

Basically, they're suing over the fact that Twitter sent a confirmatory SMS to their cellphone after they themselves used an SMS command ('STOP') meant to turn off all phone notifications .

The two men allege that Twitter has engaged in unlawful conduct by contacting them on their mobile phones without their consent, which they say is a violation of the Telephone Consumer Protection Act of 1991 (TCPA) and an invasion of their privacy.
Twitter Gets Hit With Bizarre Class Action Lawsuit Over Unsolicited SMS Notifications
Two California residents, Drew Moss and Sahar Maleksaeedi, have filed a rather peculiar class action lawsuit against Twitter (see documents embedded below). 
 Basically, they’re suing over the fact that Twitter sent a confirmatory SMS to their cellphone after they themselves used an SMS command (‘STOP’) meant to turn off all phone notifications . 
 The two men allege that Twitter has engaged in unlawful conduct by contacting them on their mobile phones without their consent, which they say is a violation of the Telephone Consumer Protection Act of 1991 (TCPA) and an invasion of their privacy. 
 Here’s the relevant part in the lawsuit documents: 
 At some point Plaintiffs decided that they no longer wanted to receive text message notifications on their cellular telephone from Defendant. 
 Plaintiffs then responded to Defendant’s last text message notification by replying “stop,” as instructed by Twitter. 
 At this point, Plaintiffs withdrew any express or implied consent to receive text message notification to their cellular telephone that they may have previous given Twitter. 
 In response to receiving this revocation of consent, Defendant then immediately sent another, unsolicited, confirmatory text message to Plaintiffs’ cellular telephones. 
 Moss and Maleksaeedi says an “automatic telephone dialing system” was employed to deliver the confirmatory message, and that they incurred a charge for incoming calls as a result. This is illegal, the two men claim, because the message in question was not sent for emergency purposes and without prior consent given. 
 According to the lawsuit documents, Moss and Maleksaeedi seek up to $1,500 in damages for each call in alleged violation of the TCPA, which, when aggregated among a proposed class number in the “tens of thousands”, would exceed the $5 million threshold for federal court jurisdiction. The suit is expressly not intended to request any recovery for personal injury. 
 I’ve contacted Twitter for comment on this rather bizarre lawsuit but haven’t heard back yet (it’s still very early in California, so we’ll update as soon as we get a response). 
 (Photo by Flickr user mira66 , used with permission) 

	
	
	
	

 twitter-complaint 
 CrunchBase Information  Twitter  Information provided by CrunchBase
The Royal Wedding is finally over, and William and Kate are hitched. The wedding goes beyond just a ceremony, the event is actually a huge business. Between replicas of Kate Middleton's engagement ring and Royal Wedding china, retailers are profiting off of the nuptials. And eBay and its merchants are part of this business. Here are a few stats related to the searches and purchases of wedding-related items on the marketplace.
eBay: Searches For Royal Wedding Products Up 1,815 Percent In 2011
The Royal Wedding is finally over, and William and Kate are hitched. The wedding goes beyond just a ceremony, the event is actually a huge business. Between replicas of Kate Middleton’s engagement ring and Royal Wedding china, retailers are profiting off of the nuptials. And eBay and its merchants are part of this business. Here are a few stats related to the searches and purchases of wedding-related items on the marketplace. 
 
 In April, more than $70,000 and 3,000 items related to the Royal Wedding have been sold on eBay
 Kate Middleton searches are five times more popular than those of Prince William
 The most expensive item sold was Kate Middleton/Princess Diana replica ring for $1,500
 Monthly eBay searches for Royal Wedding products have risen a staggering 1,815% in 2011
 
 
 CrunchBase Information  eBay  Information provided by CrunchBase
Sharing what mobile apps you have in a social network has been tried various ways. Appsfire hit on the idea of socialising apps. 

 Zwapp is coming at it from a slightly different angle. Its iPhone app ( iTunes link ) auto-discovers what apps you have on your iPhone and connects up your contacts, Facebook and Twitter friends. You then follow people who's opinion's you respect when it comes to apps. It even has a live feed where you can see what apps your friends are using and downloading (privacy is now most definitely over it would seem).
Zwapp Puts A Social Layer Over Your iPhone Apps
Sharing what mobile apps you have in a social network has been tried various ways. Appsfire hit on the idea of socialising apps. 
 Zwapp is coming at it from a slightly different angle. Its iPhone app ( iTunes link ) auto-discovers what apps you have on your iPhone and connects up your contacts, Facebook and Twitter friends. You then follow people who’s opinion’s you respect when it comes to apps. It even has a live feed where you can see what apps your friends are using and downloading (privacy is now most definitely over it would seem).
